/*
PolyGun

Copyright (c) 2023 mrkubax10 <mrkubax10@onet.pl>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef POLYGUN_MATH_RECT_HPP
#define POLYGUN_MATH_RECT_HPP

#include <glm/glm.hpp>

namespace polygun::math {
	class Rect {
	public:
		Rect(const glm::vec2& pos, const glm::vec2& size);
		Rect(float x, float y, float width, float height);
		~Rect() = default;

		Rect constrained(const glm::vec2& pos, const glm::vec2& size) const;

		float get_x() const { return m_pos.x; }
		float get_y() const { return m_pos.y; }
		float get_width() const { return m_size.x; }
		float get_height() const { return m_size.y; }
		const glm::vec2& get_size() const { return m_size; }
		float get_right() const { return m_pos.x+m_size.x; }
		float get_bottom() const { return m_pos.y+m_size.y; }

	private:
		glm::vec2 m_pos;
		glm::vec2 m_size;
	};
}

#endif // POLYGUN_MATH_RECT_HPP
